import { Point } from "@intelligentgraphics/ig.gfx.core";
import { GenerationTreeNode, BuildGenerationTreeOptions } from "./GenerationTree";
export declare type TConnectionInfo = "missing" | "none" | {
    parentComId: string;
    ownComId: string;
    parentPoint: Point;
    ownPoint: Point;
};
export declare class SceneSnapshot {
    private snapshot;
    private apiUtil;
    constructor(options: BuildGenerationTreeOptions);
    /**
     * Replaces all references to a comId with another one inside the snapshot
     *
     * @param {string} targetComId
     * @param {string} overwriteComId
     * @returns
     */
    replaceComId(targetComId: string, overwriteComId: string): void;
    getRootElements(): string[];
    getNode(comId: string): GenerationTreeNode | undefined;
    getNewConnectionInfo(comId: string): TConnectionInfo;
    restorePositionRecursively(comId: string): void;
    restorePosition(comId: string): boolean;
}
